# Unsanitized external input in SQL query

## Overview

* **Rule ID**: `java_lang_sqli`
* **Applicable Languages**: Java
* **Weakness ID**: CWE-89

## Description

Using unsanitized data, such as user input, request data, or any externally influenced data in SQL queries exposes your application to SQL injection attacks. This vulnerability occurs when external data is directly incorporated into SQL statements without adequate sanitization, enabling attackers to manipulate queries and potentially access or alter data.

## Remediation Guidelines

* **Avoid** including unsanitized input in SQL queries, as this can lead to SQL injection vulnerabilities.

  ```java
  Statement stmt = conn.createStatement();
  ResultSet rs = stmt.executeQuery("select name from users where id='" + uri.getQueryParameter("user_id") + "'"));

  ```
* **Use** prepared statements to safely incorporate external input into SQL queries.

  ```java
  PreparedStatement myStmt = myCon.prepareStatement("select * from students where age > ? and name = ?");
  myStmt.setInt(1, uri.getQueryParameter("age"));
  myStmt.setString(2, uri.getQueryParameter("name"));
  ```

## References

* [**OWASP SQL injection explained**](https://owasp.org/www-community/attacks/SQL_Injection)
* [**OWASP SQL injection prevention cheat sheet**](https://cheatsheetseries.owasp.org/cheatsheets/SQL_Injection_Prevention_Cheat_Sheet.html)
* [**CWE-89: Improper Neutralization of Special Elements used in an SQL Command ('SQL Injection') OWASP Top 10**](https://cwe.mitre.org/data/definitions/89.html)
* [**OWASP Top 10: A03:2021 - Injection**](https://owasp.org/Top10/A03_2021-Injection/)

## Configuration

To omit this rule during a scan, and to provide you with continuous 24/7 code-level scanning, you can employ our [**SAST TOOL**](https://scopy.sec1.io/login)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.sec1.io/user-docs/4-sast/2-java/unsanitized-external-input-in-sql-query.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
